# Add project specific ProGuard rules here.
# You can control the set of applied configuration files using the
# proguardFiles setting in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}
################common###############

-keep class **$Properties
-dontwarn java.beans.**
 ## ----------Apache Commons-----------##
-keep class org.apache.commons.** { *; }
-dontwarn org.apache.commons.**
  ## ----------Apache Commons-----------##
-dontwarn org.apache.log4j.**
-dontwarn org.apache.commons.logging.**
-keep class org.** { *; }
 -keepclasseswithmembernames class * {
     native <methods>;
 }

 -keepclasseswithmembernames class * {
     public <init>(android.updateLog.Context, android.util.AttributeSet);
 }

 -keepclasseswithmembernames class * {
     public <init>(android.updateLog.Context, android.util.AttributeSet, int);
 }

 -keepclassmembers enum * {
     public static **[] values();
     public static ** valueOf(java.lang.String);
 }

 -keep class * implements android.os.Parcelable {
   public static final android.os.Parcelable$Creator *;
 }

 -keepclassmembers class **.R$* {
     public static <fields>;
 }
# 保护注解
-keepattributes *Annotation*
-keep class * extends java.lang.annotation.Annotation {*;}
-keepclassmembers class ** {
    @com.hwangjr.rxbus.annotation.Subscribe <methods>;
}
-keepclassmembers class ** {
    @com.hwangjr.rxbus.annotation.Tag <methods>;
}

################Gson#######################
-keepattributes Signature
-keepattributes EnclosingMethod

# 不混淆内部类
-keepattributes InnerClasses
# Gson specific classes
-keep class sun.misc.Unsafe { *; }
# Application classes that will be serialized/deserialized over Gson
-keep class com.google.gson.** { *; }
-keep class com.google.gson.stream.** { *; }
# OkHttp
-keep class com.squareup.okhttp.** { *; }
-keep interface com.squareup.okhttp.** { *; }
-dontwarn com.squareup.okhttp.**
-keep class okhttp3.** { *; }
-dontwarn okhttp3.**
-keep class okhttp3.internal.**{*;}
-keep class okio.** { *; }

# fastjson
-dontwarn com.alibaba.fastjson.**
# Okio
-keep class sun.misc.Unsafe{ *; }
-dontwarn java.nio.file.*
-dontwarn org.codehaus.mojo.animal_sniffer.IgnoreJRERequirement
-dontwarn okio.**



-keepclassmembers enum * {
public static **[] values();
public static ** valueOf(java.lang.String);
}
-keep class org.apache.commons.lang3.**{*;}



# retrofit2
# Platform calls Class.forName on types which do not exist on Android to determine platform.
-dontnote retrofit.Platform
# Platform used when running on RoboVM on iOS. Will not be used at runtime.
# Platform used when running on Java 8 VMs. Will not be used at runtime.
-dontwarn retrofit.Platform$Java8
-dontwarn org.w3c.dom.Node
# Retain declared checked exceptions for use by a Proxy instance.
-keepattributes Exceptions
-dontwarn retrofit2.**
-dontwarn retrofit.appengine.UrlFetchClient
-keep class retrofit2.** { *; }
-keepclasseswithmembers class * {
    @retrofit.http.* <methods>;
}

#xml解析
-libraryjars <java.home>/lib/rt.jar
-keepattributes ElementList, Root
-keep public class org.simpleframework.** { *; }
-dontwarn com.bea.xml.stream.**
-dontwarn org.simpleframework.xml.stream.**
-keep class org.simpleframework.xml.**{ *; }
-keepclassmembers,allowobfuscation class * {
    @org.simpleframework.xml.* <fields>;
    @org.simpleframework.xml.* <init>(...);
}
-dontwarn javax.xml.stream.events.**
-dontwarn javax.xml.**
-keepclassmembers class * {
    @org.simpleframework.xml.* *;
}
-keep interface org.simpleframework.xml.core.Label {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Label {
   public *;
}
-keep interface org.simpleframework.xml.core.Parameter {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Parameter {
   public *;
}
-keep interface org.simpleframework.xml.core.Extractor {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Extractor {
   public *;
}

-keep class java.beans.** { *; }
-keep class test.org.tap.security.positiontable.** { *; }
-keep class org.tap.** { *; }
-keep class org.apache.log4j.** { *; }
-keep class com.tap.operation.** { *; }
-dontwarn  org.tap.security.**

-keep class rx.** { *; }
-keep class javax.** { *; }
-keep class com.miya.** { *; }
-keep class miyaapay.** { *; }
-keep class com.google.** { *; }
-keep class org.simpleframework.** { *; }
-keep class com.sdy.miya.moblie.component.pay.core.** { *; }
-keep class com.sdy.miya.moblie.component.pay.midhub.bean.** { *; }
-keep class com.sdy.miya.moblie.component.pay.midhub.sign.** { *; }
-keep class com.sdy.miya.moblie.component.pay.platform.bean.** { *; }
-keep class com.miya.** { *; }
-keep class com.sdy.miya.moblie.component.pay.platform.MiYaPlatformPayService{
 public *;
}
-keep class com.sdy.miya.moblie.component.pay.midhub.MiYaMidHubPayService{
 public *;
}
-keep class com.sdy.miya.moblie.component.pay.jar.MiYaJarPayService{
 public *;
}
-keep class MiYaPayMobileApiClient{
public *;
}
-keep class com.alibaba.fastjson.** { *; }
-keep class com.squareup.** { *; }
-dontwarn javax.**
-dontwarn rx.**
-dontwarn org.simpleframework.xml.**
-dontwarn com.google.gson.JsonParseException