package com.sdy.miya.moblie.component;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import android.Manifest;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;

import com.changqin.study.component.R;
import com.permissionx.guolindev.PermissionX;
import com.permissionx.guolindev.callback.RequestCallback;
import com.sdy.miya.moblie.component.filepicker.IFilePickerCallback;
import com.sdy.miya.moblie.component.filepicker.IFilePickerHandle;
import com.sdy.miya.moblie.component.filepicker.LFilePicker;

import java.util.ArrayList;
import java.util.List;

public class MainActivity extends AppCompatActivity implements IFilePickerCallback {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    public void openFilePicker(View view) {
        PermissionX.init(this)
                .permissions(Manifest.permission.READ_EXTERNAL_STORAGE)
                .request(new RequestCallback() {
                    @Override
                    public void onResult(boolean allGranted, @NonNull List<String> grantedList, @NonNull List<String> deniedList) {
                        if (allGranted) {
                            new LFilePicker()
                                    .withActivity(MainActivity.this)
                                    .withRequestCode(1)
                                    //.withStartPath(CACHE_FILE_PATH)//指定初始显示路径
                                    .withIsGreater(true)//过滤文件大小 小于指定大小的文件
                                    .withFileSize(0)//指定文件大小为500K
                                    .withMutilyMode(false)
                                    .registerCallBack(MainActivity.this)
                                    .start();
                        }
                    }
                });

    }

    public void testClose(View view) {

    }

    @Override
    public void onChoseFile(ArrayList<String> choseFiles, String path, IFilePickerHandle handle) {
        if (choseFiles!=null && choseFiles.size() >0) {
            Log.d("qqq", choseFiles.get(0));
            new Handler().postDelayed(new Runnable() {
                @Override
                public void run() {
                    handle.hideLoading();
                    handle.CloseFilePicker();
                }
            }, 5000);
        }
    }
}